#pragma once

#include <SDL2/SDL_rect.h>	 // for SDL_Point, SDL_Rect
#include <SDL2/SDL_render.h> // for SDL_Renderer, SDL_Texture
#include <SDL2/SDL_stdinc.h> // for Uint32
#include <memory>			 // for unique_ptr
#include <string>			 // for string, basic_string
#include <vector>			 // for vector
#include "utils.h"			 // for Color
#include "sprite.h"			 // lines 11-11
#include "text.h"			 // lines 12-12
#include "texture.h"		 // lines 13-13

// Defines
constexpr int SCOREBOARD_LEFT_PANEL = 0;
constexpr int SCOREBOARD_CENTER_PANEL = 1;
constexpr int SCOREBOARD_RIGHT_PANEL = 2;
constexpr int SCOREBOARD_MAX_PANELS = 3;
constexpr int SCOREBOARD_TICK_SPEED = 100;

// Enums
enum class ScoreboardMode
{
	SCORE,
	STAGE_INFO,
	CONTINUE,
	WAITING,
	GAME_OVER,
	DEMO,
	ENTER_NAME,
	NUM_MODES,
};

// Structs
struct panel_t
{
	ScoreboardMode mode; // Modo en el que se encuentra el panel
	SDL_Rect pos;		 // Posición donde dibujar el panel dentro del marcador
};

// Clase Scoreboard
class Scoreboard
{
private:
	// [SINGLETON] Objeto scoreboard privado para Don Melitón
	static Scoreboard *scoreboard;

	// Objetos y punteros
	SDL_Renderer *renderer; // El renderizador de la ventana

	std::shared_ptr<Texture> gamePowerMeterTexture; // Textura con el marcador de poder de la fase
	std::unique_ptr<Sprite> powerMeterSprite;		// Sprite para el medidor de poder de la fase
	std::unique_ptr<Text> textScoreBoard;			// Fuente para el marcador del juego

	SDL_Texture *background;				 // Textura para dibujar el marcador
	std::vector<SDL_Texture *> panelTexture; // Texturas para dibujar cada panel;

	// Variables
	int stage;									   // Número de fase actual
	std::string name[SCOREBOARD_MAX_PANELS];	   // Nom de cada jugador
	std::string recordName[SCOREBOARD_MAX_PANELS]; // Nombre introducido para la tabla de records
	int selectorPos[SCOREBOARD_MAX_PANELS];		   // Posición del selector de letra para introducir el nombre
	int score[SCOREBOARD_MAX_PANELS];			   // Puntuación de los jugadores
	float mult[SCOREBOARD_MAX_PANELS];			   // Multiplicador de los jugadores
	int continueCounter[SCOREBOARD_MAX_PANELS];	   // Tiempo para continuar de los jugadores
	int hiScore;								   // Máxima puntuación
	float power;								   // Poder actual de la fase
	std::string hiScoreName;					   // Nombre del jugador con la máxima puntuación
	Color color;								   // Color del marcador
	SDL_Rect rect;								   // Posición y dimensiones del marcador
	panel_t panel[SCOREBOARD_MAX_PANELS];		   // Lista con todos los paneles del marcador
	Uint32 ticks;								   // Variable donde almacenar el valor de SDL_GetTiks()
	int counter;								   // Contador

	// Puntos predefinidos para colocar elementos en los paneles
	SDL_Point slot4_1, slot4_2, slot4_3, slot4_4;
	SDL_Point enterNamePos;

	// Recalcula las anclas de los elementos
	void recalculateAnchors();

	// Transforma un valor numérico en una cadena de 6 cifras
	std::string updateScoreText(int num);

	// Crea la textura de fondo
	void createBackgroundTexture();

	// Crea las texturas de los paneles
	void createPanelTextures();

	// Rellena los diferentes paneles del marcador
	void fillPanelTextures();

	// Rellena la textura de fondo
	void fillBackgroundTexture();

	// Actualiza el contador
	void updateCounter();

	// Dibuja la linea que separa la zona de juego del marcador
	void renderSeparator();

	// [SINGLETON] Ahora el constructor y el destructor son privados

	// Constructor
	Scoreboard(SDL_Renderer *renderer);

	// Destructor
	~Scoreboard();

public:
	// [SINGLETON] Crearemos el objeto scoreboard con esta función estática
	static void init(SDL_Renderer *renderer);

	// [SINGLETON] Destruiremos el objeto scoreboard con esta función estática
	static void destroy();

	// [SINGLETON] Con este método obtenemos el objeto scoreboard y podemos trabajar con él
	static Scoreboard *get();

	// Actualiza la lógica del marcador
	void update();

	// Pinta el marcador
	void render();

	// Establece el valor de la variable
	void setName(int panel, std::string name);

	// Establece el valor de la variable
	void setRecordName(int panel, std::string recordName);

	// Establece el valor de la variable
	void setSelectorPos(int panel, int pos);

	// Establece el valor de la variable
	void setScore(int panel, int score);

	// Establece el valor de la variable
	void setMult(int panel, float mult);

	// Establece el valor de la variable
	void setContinue(int panel, int score);

	// Establece el valor de la variable
	void setStage(int stage);

	// Establece el valor de la variable
	void setHiScore(int hiScore);

	// Establece el valor de la variable
	void setPower(float power);

	// Establece el valor de la variable
	void setHiScoreName(std::string name);

	// Establece el valor de la variable
	void setColor(Color color);

	// Establece el valor de la variable
	void setPos(SDL_Rect rect);

	// Establece el modo del marcador
	void setMode(int index, ScoreboardMode mode);
};
